---
title: insert_part
type: processor
status: stable
categories: ["Composition"]
---

<!--
     THIS FILE IS AUTOGENERATED!

     To make changes please edit the contents of:
     lib/processor/insert_part.go
-->

import Tabs from '@theme/Tabs';
import TabItem from '@theme/TabItem';


Insert a new message into a batch at an index. If the specified index is greater
than the length of the existing batch it will be appended to the end.

```yaml
# Config fields, showing default values
label: ""
insert_part:
  index: -1
  content: ""
```

The index can be negative, and if so the message will be inserted from the end
counting backwards starting from -1. E.g. if index = -1 then the new message
will become the last of the batch, if index = -2 then the new message will be
inserted before the last message, and so on. If the negative index is greater
than the length of the existing batch it will be inserted at the beginning.

The new message will have metadata copied from the first pre-existing message of
the batch.

This processor will interpolate functions within the 'content' field, you can
find a list of functions [here](/docs/configuration/interpolation#bloblang-queries).

## Fields

### `index`

The index within the batch to insert the message at.


Type: `int`  
Default: `-1`  

### `content`

The content of the message being inserted.
This field supports [interpolation functions](/docs/configuration/interpolation#bloblang-queries).


Type: `string`  
Default: `""`  


